Index: branches/HM-10.0-dev-SHM/source/App/TAppDecoder/TAppDecCfg.cpp
===================================================================
--- branches/HM-10.0-dev-SHM/source/App/TAppDecoder/TAppDecCfg.cpp	(revision 51)
+++ branches/HM-10.0-dev-SHM/source/App/TAppDecoder/TAppDecCfg.cpp	(revision 54)
@@ -41,4 +41,7 @@
 #include "TAppDecCfg.h"
 #include "TAppCommon/program_options_lite.h"
+#if SVC_EXTENSION
+#include <cassert>
+#endif
 
 #ifdef WIN32
@@ -63,5 +66,16 @@
   Bool do_help = false;
   string cfg_BitstreamFile;
+#if SVC_EXTENSION
+  string cfg_ReconFile [MAX_LAYERS];
+  Int nLayerNum;
+#if AVC_BASE
+  string cfg_BLReconFile;
+#endif
+#else
   string cfg_ReconFile;
+#endif
+#if AVC_SYNTAX || SYNTAX_OUTPUT
+  string cfg_BLSyntaxFile;
+#endif
   string cfg_TargetDecLayerIdSetFile;
 
@@ -70,9 +84,31 @@
   ("help", do_help, false, "this help text")
   ("BitstreamFile,b", cfg_BitstreamFile, string(""), "bitstream input file name")
+#if SVC_EXTENSION
+  ("ReconFileL%d,-o%d",   cfg_ReconFile,   string(""), MAX_LAYERS, "Layer %d reconstructed YUV output file name\n"
+                                                     "YUV writing is skipped if omitted")
+#if AVC_BASE
+  ("BLReconFile,-ibl",    cfg_BLReconFile,  string(""), "BL reconstructed YUV input file name")
+  ("BLSourceWidth,-wdt",    m_iBLSourceWidth,        0, "BL source picture width")
+  ("BLSourceHeight,-hgt",   m_iBLSourceHeight,       0, "BL source picture height")
+#if AVC_SYNTAX
+  ("BLSyntaxFile,-ibs",    cfg_BLSyntaxFile,  string(""), "BL syntax input file name")  
+#endif
+#endif
+#else
   ("ReconFile,o",     cfg_ReconFile,     string(""), "reconstructed YUV output file name\n"
                                                      "YUV writing is skipped if omitted")
+#endif
+#if SYNTAX_OUTPUT
+  ("BLSyntaxFile,-ibs",    cfg_BLSyntaxFile,  string(""), "BL syntax input file name")
+  ("BLSourceWidth,-wdt",    m_iBLSourceWidth,        0, "BL source picture width")
+  ("BLSourceHeight,-hgt",   m_iBLSourceHeight,       0, "BL source picture height")
+  ("BLFrames,-fr",          m_iBLFrames,       0, "BL number of frames")
+#endif
   ("SkipFrames,s", m_iSkipFrame, 0, "number of frames to skip before random access")
   ("OutputBitDepth,d", m_outputBitDepthY, 0, "bit depth of YUV output luma component (default: use 0 for native depth)")
   ("OutputBitDepthC,d", m_outputBitDepthC, 0, "bit depth of YUV output chroma component (default: use 0 for native depth)")
+#if SVC_EXTENSION
+  ("LayerNum,-ls", nLayerNum, 1, "Number of layers to be decoded.")
+#endif 
   ("MaxTemporalLayer,t", m_iMaxTemporalLayer, -1, "Maximum Temporal Layer to be decoded. -1 to decode all layers")
   ("SEIDecodedPictureHash", m_decodedPictureHashSEIEnabled, 1, "Control handling of decoded picture hash SEI messages\n"
@@ -99,5 +135,20 @@
   /* convert std::string to c string for compatability */
   m_pchBitstreamFile = cfg_BitstreamFile.empty() ? NULL : strdup(cfg_BitstreamFile.c_str());
+#if SVC_EXTENSION
+  m_tgtLayerId = nLayerNum - 1;
+  assert( m_tgtLayerId >= 0 );
+  for(UInt layer=0; layer<= m_tgtLayerId; layer++)
+  {
+    m_pchReconFile[layer] = cfg_ReconFile[layer].empty() ? NULL : strdup(cfg_ReconFile[layer].c_str());
+  }
+#if AVC_BASE
+  m_pchBLReconFile = cfg_BLReconFile.empty() ? NULL : strdup(cfg_BLReconFile.c_str());
+#endif
+#else
   m_pchReconFile = cfg_ReconFile.empty() ? NULL : strdup(cfg_ReconFile.c_str());
+#endif
+#if AVC_SYNTAX || SYNTAX_OUTPUT
+  m_pchBLSyntaxFile = cfg_BLSyntaxFile.empty() ? NULL : strdup(cfg_BLSyntaxFile.c_str());
+#endif
 
   if (!m_pchBitstreamFile)
Index: branches/HM-10.0-dev-SHM/source/App/TAppDecoder/TAppDecCfg.h
===================================================================
--- branches/HM-10.0-dev-SHM/source/App/TAppDecoder/TAppDecCfg.h	(revision 51)
+++ branches/HM-10.0-dev-SHM/source/App/TAppDecoder/TAppDecCfg.h	(revision 54)
@@ -58,5 +58,23 @@
 protected:
   Char*         m_pchBitstreamFile;                   ///< input bitstream file name
+#if SVC_EXTENSION
+  Char*         m_pchReconFile [MAX_LAYERS];          ///< output reconstruction file name
+#if AVC_BASE
+  Char*         m_pchBLReconFile;                     ///< input BL reconstruction file name
+  Int           m_iBLSourceWidth;
+  Int           m_iBLSourceHeight;
+#if AVC_SYNTAX
+  Char*         m_pchBLSyntaxFile;                     ///< input BL syntax file name  
+#endif
+#endif
+#else
   Char*         m_pchReconFile;                       ///< output reconstruction file name
+#endif
+#if SYNTAX_OUTPUT
+  Char*         m_pchBLSyntaxFile;                     ///< input BL syntax file name
+  Int           m_iBLSourceWidth;
+  Int           m_iBLSourceHeight;
+  Int           m_iBLFrames;
+#endif
   Int           m_iSkipFrame;                         ///< counter for frames prior to the random access point to skip
   Int           m_outputBitDepthY;                     ///< bit depth used for writing output (luma)
@@ -66,4 +84,7 @@
   Int           m_decodedPictureHashSEIEnabled;       ///< Checksum(3)/CRC(2)/MD5(1)/disable(0) acting on decoded picture hash SEI message
 
+#if SVC_EXTENSION
+  Int           m_tgtLayerId;                        ///< target layer ID
+#endif
   std::vector<Int> m_targetDecLayerIdSet;             ///< set of LayerIds to be included in the sub-bitstream extraction process.
   Int           m_respectDefDispWindow;               ///< Only output content inside the default display window 
@@ -72,5 +93,9 @@
   TAppDecCfg()
   : m_pchBitstreamFile(NULL)
+#if SVC_EXTENSION
+  , m_tgtLayerId(0)
+#else
   , m_pchReconFile(NULL) 
+#endif
   , m_iSkipFrame(0)
   , m_outputBitDepthY(0)
@@ -79,4 +104,13 @@
   , m_decodedPictureHashSEIEnabled(0)
   , m_respectDefDispWindow(0)
+#if AVC_BASE
+  , m_iBLSourceWidth(0)
+  , m_iBLSourceHeight(0)
+#endif
+#if SYNTAX_OUTPUT
+  , m_iBLSourceWidth(0)
+  , m_iBLSourceHeight(0)
+  , m_iBLFrames(0)
+#endif
   {}
   virtual ~TAppDecCfg() {}
Index: branches/HM-10.0-dev-SHM/source/App/TAppDecoder/TAppDecTop.cpp
===================================================================
--- branches/HM-10.0-dev-SHM/source/App/TAppDecoder/TAppDecTop.cpp	(revision 51)
+++ branches/HM-10.0-dev-SHM/source/App/TAppDecoder/TAppDecTop.cpp	(revision 54)
@@ -53,4 +53,15 @@
 // ====================================================================================================================
 
+#if SVC_EXTENSION
+TAppDecTop::TAppDecTop()
+{
+  ::memset (m_abDecFlag, 0, sizeof (m_abDecFlag));
+  for(UInt layer=0; layer < MAX_LAYERS; layer++)
+  {
+    m_aiPOCLastDisplay[layer]  = -MAX_INT;
+    m_apcTDecTop[layer] = &m_acTDecTop[layer];
+  }
+}
+#else
 TAppDecTop::TAppDecTop()
 : m_iPOCLastDisplay(-MAX_INT)
@@ -58,4 +69,5 @@
   ::memset (m_abDecFlag, 0, sizeof (m_abDecFlag));
 }
+#endif
 
 Void TAppDecTop::create()
@@ -70,4 +82,21 @@
     m_pchBitstreamFile = NULL;
   }
+#if SVC_EXTENSION   
+  for( Int i = 0; i < m_tgtLayerId; i++ )
+  {
+    if( m_pchReconFile[i] )
+    {
+      free ( m_pchReconFile[i] );
+      m_pchReconFile[i] = NULL;
+    }
+  }  
+#if AVC_BASE
+  if( m_pchBLReconFile )
+  {
+    free ( m_pchBLReconFile );
+    m_pchBLReconFile = NULL;
+  }
+#endif
+#else
   if (m_pchReconFile)
   {
@@ -75,4 +104,12 @@
     m_pchReconFile = NULL;
   }
+#endif
+#if AVC_SYNTAX || SYNTAX_OUTPUT
+  if( m_pchBLSyntaxFile )
+  {
+    free ( m_pchBLSyntaxFile );
+    m_pchBLSyntaxFile = NULL;
+  }
+#endif
 }
 
@@ -89,4 +126,177 @@
  .
  */
+#if SVC_EXTENSION
+Void TAppDecTop::decode()
+{
+  Int                poc;
+  TComList<TComPic*>* pcListPic = NULL;
+
+  ifstream bitstreamFile(m_pchBitstreamFile, ifstream::in | ifstream::binary);
+  if (!bitstreamFile)
+  {
+    fprintf(stderr, "\nfailed to open bitstream file `%s' for reading\n", m_pchBitstreamFile);
+    exit(EXIT_FAILURE);
+  }
+
+  InputByteStream bytestream(bitstreamFile);
+
+  // create & initialize internal classes
+  xCreateDecLib();
+  xInitDecLib  ();
+
+  // main decoder loop
+  Bool recon_opened[MAX_LAYERS]; // reconstruction file not yet opened. (must be performed after SPS is seen)
+  for(UInt layer=0; layer<=m_tgtLayerId; layer++)
+  {
+    recon_opened[layer] = false;
+    m_aiPOCLastDisplay[layer] += m_iSkipFrame;      // set the last displayed POC correctly for skip forward.
+  }
+
+  UInt curLayerId = 0;     // current layer to be reconstructed
+
+#if AVC_BASE
+  TComPic pcBLPic;
+  if( !m_pchBLReconFile )
+  {
+    printf( "Wrong base layer YUV input file\n" );
+    exit(EXIT_FAILURE);
+  }
+  fstream streamYUV( m_pchBLReconFile, fstream::in | fstream::binary );
+  if( !streamYUV.good() )
+  {
+    printf( "Base layer YUV input reading error\n" );
+    exit(EXIT_FAILURE);
+  }
+  TComList<TComPic*> *cListPic = m_acTDecTop[0].getListPic();
+  m_acTDecTop[0].setBLsize( m_iBLSourceWidth, m_iBLSourceHeight );
+  m_acTDecTop[0].setBLReconFile( &streamYUV );
+  pcBLPic.setLayerId( 0 );
+  cListPic->pushBack( &pcBLPic );
+#if AVC_SYNTAX
+  if( !m_pchBLSyntaxFile )
+  {
+    printf( "Wrong base layer syntax file\n" );
+    exit(EXIT_FAILURE);
+  }
+  fstream streamSyntaxFile( m_pchBLSyntaxFile, fstream::in | fstream::binary );
+  if( !streamSyntaxFile.good() )
+  {
+    printf( "Base layer syntax input reading error\n" );
+    exit(EXIT_FAILURE);
+  }
+  m_acTDecTop[0].setBLSyntaxFile( &streamSyntaxFile );
+#endif
+#endif
+
+  while (!!bitstreamFile)
+  {
+    /* location serves to work around a design fault in the decoder, whereby
+     * the process of reading a new slice that is the first slice of a new frame
+     * requires the TDecTop::decode() method to be called again with the same
+     * nal unit. */
+    streampos location = bitstreamFile.tellg();
+    AnnexBStats stats = AnnexBStats();
+
+    vector<uint8_t> nalUnit;
+    InputNALUnit nalu;
+    byteStreamNALUnit(bytestream, nalUnit, stats);
+
+    // call actual decoding function
+    Bool bNewPicture = false;
+    Bool bNewPOC = false;
+    if (nalUnit.empty())
+    {
+      /* this can happen if the following occur:
+       *  - empty input file
+       *  - two back-to-back start_code_prefixes
+       *  - start_code_prefix immediately followed by EOF
+       */
+      fprintf(stderr, "Warning: Attempt to decode an empty NAL unit\n");
+    }
+    else
+    {
+      read(nalu, nalUnit);
+      if( (m_iMaxTemporalLayer >= 0 && nalu.m_temporalId > m_iMaxTemporalLayer) || !isNaluWithinTargetDecLayerIdSet(&nalu)  ||
+        (nalu.m_layerId > m_tgtLayerId) )
+      {
+        bNewPicture = false;
+      }
+      else
+      {
+        bNewPicture = m_acTDecTop[nalu.m_layerId].decode(nalu, m_iSkipFrame, m_aiPOCLastDisplay[nalu.m_layerId], curLayerId, bNewPOC);
+        if (bNewPicture)
+        {
+          bitstreamFile.clear();
+          /* location points to the current nalunit payload[1] due to the
+           * need for the annexB parser to read three extra bytes.
+           * [1] except for the first NAL unit in the file
+           *     (but bNewPicture doesn't happen then) */
+          bitstreamFile.seekg(location-streamoff(3));
+          bytestream.reset();
+        }
+      }
+    }
+    if (bNewPicture || !bitstreamFile)
+    {
+      m_acTDecTop[curLayerId].executeLoopFilters(poc, pcListPic);
+    }
+
+    if( pcListPic )
+    {
+      if ( m_pchReconFile[curLayerId] && !recon_opened[curLayerId] )
+      {
+        if (!m_outputBitDepthY) { m_outputBitDepthY = g_bitDepthY; }        
+        if (!m_outputBitDepthC) { m_outputBitDepthC = g_bitDepthC; }
+
+        m_acTVideoIOYuvReconFile[curLayerId].open( m_pchReconFile[curLayerId], true, m_outputBitDepthY, m_outputBitDepthC, g_bitDepthY, g_bitDepthC ); // write mode
+
+        recon_opened[curLayerId] = true;
+      }
+      if ( bNewPicture && bNewPOC && 
+           (   nalu.m_nalUnitType == NAL_UNIT_CODED_SLICE_IDR
+            || nalu.m_nalUnitType == NAL_UNIT_CODED_SLICE_IDR_N_LP
+            || nalu.m_nalUnitType == NAL_UNIT_CODED_SLICE_BLA_N_LP
+            || nalu.m_nalUnitType == NAL_UNIT_CODED_SLICE_BLANT
+            || nalu.m_nalUnitType == NAL_UNIT_CODED_SLICE_BLA ) )
+      {
+        xFlushOutput( pcListPic, curLayerId );
+      }
+      // write reconstruction to file
+      if(bNewPicture)
+      {
+        xWriteOutput( pcListPic, curLayerId, nalu.m_temporalId );
+      }
+    }
+  }
+  for(UInt layer = 0; layer <= m_tgtLayerId; layer++)
+  {
+    xFlushOutput( m_acTDecTop[layer].getListPic(), layer );
+  }
+  // delete buffers
+#if AVC_BASE
+  if( streamYUV.is_open() )
+  {
+    streamYUV.close();
+  }
+#if AVC_SYNTAX
+  if( streamSyntaxFile.is_open() )
+  {
+    streamSyntaxFile.close();
+  }
+#endif
+  pcBLPic.destroy();
+
+  for(UInt layer = 1; layer <= m_tgtLayerId; layer++)
+#else
+  for(UInt layer = 0; layer <= m_tgtLayerId; layer++)
+#endif
+  {
+    m_acTDecTop[layer].deletePicBuffer();
+  }
+  
+  // destroy internal classes
+  xDestroyDecLib();
+}
+#else
 Void TAppDecTop::decode()
 {
@@ -110,4 +320,25 @@
   // main decoder loop
   Bool recon_opened = false; // reconstruction file not yet opened. (must be performed after SPS is seen)
+
+#if SYNTAX_OUTPUT
+  if( !m_pchBLSyntaxFile )
+  {
+    printf( "Wrong base layer syntax file\n" );
+    exit(EXIT_FAILURE);
+  }
+  fstream streamSyntaxFile( m_pchBLSyntaxFile, fstream::out | fstream::binary );
+  if( !streamSyntaxFile.good() )
+  {
+    printf( "Base layer syntax input reading error\n" );
+    exit(EXIT_FAILURE);
+  }
+  m_cTDecTop.setBLSyntaxFile( &streamSyntaxFile );
+
+  for( Int i = m_iBLFrames * m_iBLSourceWidth * m_iBLSourceHeight * SYNTAX_BYTES / 16; i >= 0; i-- )
+  {
+    streamSyntaxFile.put( 0 );
+  }
+  streamSyntaxFile.seekp( 0 );
+#endif
 
   while (!!bitstreamFile)
@@ -199,4 +430,11 @@
   }
   
+#if SYNTAX_OUTPUT
+  if( streamSyntaxFile.is_open() )
+  {
+    streamSyntaxFile.close();
+  }
+#endif
+  
   xFlushOutput( pcListPic );
   // delete buffers
@@ -206,4 +444,5 @@
   xDestroyDecLib();
 }
+#endif
 
 // ====================================================================================================================
@@ -213,10 +452,41 @@
 Void TAppDecTop::xCreateDecLib()
 {
+#if SVC_EXTENSION
+  // initialize global variables
+  initROM();  
+
+  for(UInt layer = 0; layer <= m_tgtLayerId; layer++)
+  {
+    // set layer ID
+    m_acTDecTop[layer].setLayerId                      ( layer );
+
+    // create decoder class
+    m_acTDecTop[layer].create();
+
+    m_acTDecTop[layer].setLayerDec(m_apcTDecTop);   
+  }
+#else
   // create decoder class
   m_cTDecTop.create();
+#endif
 }
 
 Void TAppDecTop::xDestroyDecLib()
 {
+#if SVC_EXTENSION
+  // destroy ROM
+  destroyROM();
+
+  for(UInt layer = 0; layer <= m_tgtLayerId; layer++)
+  {
+    if ( m_pchReconFile[layer] )
+    {
+      m_acTVideoIOYuvReconFile[layer]. close();
+    }
+
+    // destroy decoder class
+    m_acTDecTop[layer].destroy();
+  }
+#else
   if ( m_pchReconFile )
   {
@@ -226,4 +496,5 @@
   // destroy decoder class
   m_cTDecTop.destroy();
+#endif
 }
 
@@ -231,6 +502,16 @@
 {
   // initialize decoder class
+#if SVC_EXTENSION
+  for(UInt layer = 0; layer <= m_tgtLayerId; layer++)
+  {
+    m_acTDecTop[layer].init();
+    m_acTDecTop[layer].setDecodedPictureHashSEIEnabled(m_decodedPictureHashSEIEnabled);
+    m_acTDecTop[layer].setNumLayer( m_tgtLayerId + 1 );
+  }
+
+#else
   m_cTDecTop.init();
   m_cTDecTop.setDecodedPictureHashSEIEnabled(m_decodedPictureHashSEIEnabled);
+#endif
 }
 
@@ -238,5 +519,9 @@
     \todo            DYN_REF_FREE should be revised
  */
+#if SVC_EXTENSION
+Void TAppDecTop::xWriteOutput( TComList<TComPic*>* pcListPic, UInt layerId, UInt tId )
+#else
 Void TAppDecTop::xWriteOutput( TComList<TComPic*>* pcListPic, UInt tId )
+#endif
 {
   TComList<TComPic*>::iterator iterPic   = pcListPic->begin();
@@ -246,5 +531,9 @@
   {
     TComPic* pcPic = *(iterPic);
+#if SVC_EXTENSION
+    if(pcPic->getOutputMark() && pcPic->getPOC() > m_aiPOCLastDisplay[layerId])
+#else
     if(pcPic->getOutputMark() && pcPic->getPOC() > m_iPOCLastDisplay)
+#endif
     {
        not_displayed++;
@@ -258,8 +547,27 @@
     TComPic* pcPic = *(iterPic);
     
+#if SVC_EXTENSION
+    if ( pcPic->getOutputMark() && (not_displayed >  pcPic->getNumReorderPics(tId) && pcPic->getPOC() > m_aiPOCLastDisplay[layerId]))
+#else
     if ( pcPic->getOutputMark() && (not_displayed >  pcPic->getNumReorderPics(tId) && pcPic->getPOC() > m_iPOCLastDisplay))
+#endif
     {
       // write to file
        not_displayed--;
+#if SVC_EXTENSION
+      if ( m_pchReconFile[layerId] )
+      {
+        const Window &conf = pcPic->getConformanceWindow();
+        const Window &defDisp = m_respectDefDispWindow ? pcPic->getDefDisplayWindow() : Window();
+        m_acTVideoIOYuvReconFile[layerId].write( pcPic->getPicYuvRec(),
+                                       conf.getWindowLeftOffset() + defDisp.getWindowLeftOffset(),
+                                       conf.getWindowRightOffset() + defDisp.getWindowRightOffset(),
+                                       conf.getWindowTopOffset() + defDisp.getWindowTopOffset(),
+                                       conf.getWindowBottomOffset() + defDisp.getWindowBottomOffset() );
+      }
+      
+      // update POC of display order
+      m_aiPOCLastDisplay[layerId] = pcPic->getPOC();
+#else
       if ( m_pchReconFile )
       {
@@ -275,4 +583,5 @@
       // update POC of display order
       m_iPOCLastDisplay = pcPic->getPOC();
+#endif
       
       // erase non-referenced picture in the reference picture list after display
@@ -302,5 +611,9 @@
     \todo            DYN_REF_FREE should be revised
  */
+#if SVC_EXTENSION
+Void TAppDecTop::xFlushOutput( TComList<TComPic*>* pcListPic, UInt layerId )
+#else
 Void TAppDecTop::xFlushOutput( TComList<TComPic*>* pcListPic )
+#endif
 {
   if(!pcListPic)
@@ -319,4 +632,19 @@
     {
       // write to file
+#if SVC_EXTENSION
+      if ( m_pchReconFile[layerId] )
+      {
+        const Window &conf = pcPic->getConformanceWindow();
+        const Window &defDisp = m_respectDefDispWindow ? pcPic->getDefDisplayWindow() : Window();
+        m_acTVideoIOYuvReconFile[layerId].write( pcPic->getPicYuvRec(),
+                                       conf.getWindowLeftOffset() + defDisp.getWindowLeftOffset(),
+                                       conf.getWindowRightOffset() + defDisp.getWindowRightOffset(),
+                                       conf.getWindowTopOffset() + defDisp.getWindowTopOffset(),
+                                       conf.getWindowBottomOffset() + defDisp.getWindowBottomOffset() );
+      }
+      
+      // update POC of display order
+      m_aiPOCLastDisplay[layerId] = pcPic->getPOC();
+#else
       if ( m_pchReconFile )
       {
@@ -332,4 +660,5 @@
       // update POC of display order
       m_iPOCLastDisplay = pcPic->getPOC();
+#endif
       
       // erase non-referenced picture in the reference picture list after display
@@ -351,4 +680,5 @@
       pcPic->setOutputMark(false);
     }
+#if !SVC_EXTENSION
 #if !DYN_REF_FREE
     if(pcPic)
@@ -359,8 +689,13 @@
     }
 #endif    
+#endif
     iterPic++;
   }
+#if SVC_EXTENSION
+  m_aiPOCLastDisplay[layerId] = -MAX_INT;
+#else
   pcListPic->clear();
   m_iPOCLastDisplay = -MAX_INT;
+#endif
 }
 
Index: branches/HM-10.0-dev-SHM/source/App/TAppDecoder/TAppDecTop.h
===================================================================
--- branches/HM-10.0-dev-SHM/source/App/TAppDecoder/TAppDecTop.h	(revision 51)
+++ branches/HM-10.0-dev-SHM/source/App/TAppDecoder/TAppDecTop.h	(revision 54)
@@ -61,10 +61,20 @@
 private:
   // class interface
+#if SVC_EXTENSION
+  TDecTop                         m_acTDecTop [MAX_LAYERS];                    ///< decoder class 
+  TDecTop*                        m_apcTDecTop [MAX_LAYERS];                   ///< decoder point class 
+  TVideoIOYuv                     m_acTVideoIOYuvReconFile [MAX_LAYERS];        ///< reconstruction YUV class
+#else
   TDecTop                         m_cTDecTop;                     ///< decoder class
   TVideoIOYuv                     m_cTVideoIOYuvReconFile;        ///< reconstruction YUV class
+#endif
   
   // for output control
   Bool                            m_abDecFlag[ MAX_GOP ];         ///< decoded flag in one GOP
+#if SVC_EXTENSION
+  Int                             m_aiPOCLastDisplay [MAX_LAYERS]; ///< last POC in display order
+#else
   Int                             m_iPOCLastDisplay;              ///< last POC in display order
+#endif
   
 public:
@@ -81,6 +91,11 @@
   Void  xInitDecLib       (); ///< initialize decoder class
   
+#if SVC_EXTENSION
+  Void  xWriteOutput      ( TComList<TComPic*>* pcListPic, UInt layerId, UInt tId ); ///< write YUV to file
+  Void  xFlushOutput      ( TComList<TComPic*>* pcListPic, UInt layerId ); ///< flush all remaining decoded pictures to file
+#else
   Void  xWriteOutput      ( TComList<TComPic*>* pcListPic , UInt tId); ///< write YUV to file
   Void  xFlushOutput      ( TComList<TComPic*>* pcListPic ); ///< flush all remaining decoded pictures to file
+#endif
   Bool  isNaluWithinTargetDecLayerIdSet ( InputNALUnit* nalu ); ///< check whether given Nalu is within targetDecLayerIdSet
 };
Index: branches/HM-10.0-dev-SHM/source/App/TAppDecoder/decmain.cpp
===================================================================
--- branches/HM-10.0-dev-SHM/source/App/TAppDecoder/decmain.cpp	(revision 51)
+++ branches/HM-10.0-dev-SHM/source/App/TAppDecoder/decmain.cpp	(revision 54)
@@ -56,5 +56,5 @@
   // print information
   fprintf( stdout, "\n" );
-  fprintf( stdout, "HM software: Decoder Version [%s]", NV_VERSION );
+  fprintf( stdout, "SHM software: Decoder Version [%s]", NV_VERSION );
   fprintf( stdout, NVM_ONOS );
   fprintf( stdout, NVM_COMPILEDBY );
